<script>
import {useStore} from "vuex";
import ProductService from "@/service/ProductService";
import {HOST_API} from "@/vars";

export default {
  name: 'ProjectsQualified',
  setup() {
    const store = useStore()
    const productService = new ProductService();
    return {
      store,
      productService,
    }
  },
  data: () => ({
    projects: null,
    status: null,
    status_friendly: {
      "qualified": "Calificados",
      "review": "Por calificar",
      "not-qualifier": "Sin calificador",
      "draft": "En Borrador",
    }
  }),
  async created() {
    this.status = this.$route.params.status;

    await this.getProject(this.status)

    this.$watch(
        () => this.$route.params,
        async (toParams, previousParams) => {
          await this.getProject(toParams.status)
        }
    );
  },
  computed: {
    renderStatus() {
      if (this.status) {
        return this.status_friendly[this.status]
      }
    },
  },
  methods: {
    async getProject(status) {
      if (!status) return

      this.status = status;
      const response = await fetch(HOST_API + `/projects/${status}/`, {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      })
      this.projects = await response.json()
    },

  }
}
</script>

<template>
  <div class="grid">
    <div class="col-12 xl:col-12">
      <div class="card">
        <h5>Proyectos {{ renderStatus }}</h5>
        <DataTable
            v-if="projects"
            :value="projects.data"
            dataKey="id"
            :rows="5"
            :paginator="true"
            responsiveLayout="scroll">
          <Column field="title" header="Título" :sortable="true" style="width: 35%"></Column>
          <Column field="description" header="Descripción" :sortable="true" style="width: 35%"></Column>
          <Column field="status" header="Estado" :sortable="true" style="width: 35%"></Column>
          <Column style="width: 15%">
            <template #header> Ver</template>
            <template #body="slotProps">
              <router-link :to="{name: 'project_edit', params: {'id': slotProps.data.id}}">
                <Button icon="pi pi-search" type="button" class="p-button-text"></Button>
              </router-link>
            </template>
          </Column>
        </DataTable>
      </div>
    </div>
  </div>
</template>
